// Generated by javascript generator


import { assertAny } from "../root";
import { assertArray } from "../root";
import { assertBigInteger } from "../root";
import { assertBuffer } from "../root";
import { assertNumber } from "../root";
import { assertObject } from "../root";
import { assertSet } from "../root";
import { assertString } from "../root";

/**
* @return {QueryObject}
*/
export function returnTypeEnumQueryObject() {
	return { name: "return_type_enum" };
}

/**
* @return {QueryObject}
*/
export function returnTypeBooleanQueryObject() {
	return { name: "return_type_boolean" };
}

/**
* @return {QueryObject}
*/
export function returnTypeIntegerQueryObject() {
	return { name: "return_type_integer" };
}

/**
* @return {QueryObject}
*/
export function returnTypeBigIntegerQueryObject() {
	return { name: "return_type_big_integer" };
}

/**
* @return {QueryObject}
*/
export function returnTypeTextQueryObject() {
	return { name: "return_type_text" };
}

/**
* @return {QueryObject}
*/
export function returnTypeDecimalQueryObject() {
	return { name: "return_type_decimal" };
}

/**
* @return {QueryObject}
*/
export function returnTypeByteArrayQueryObject() {
	return { name: "return_type_byte_array" };
}

/**
* @return {QueryObject}
*/
export function returnTypePubkeyQueryObject() {
	return { name: "return_type_pubkey" };
}

/**
* @return {QueryObject}
*/
export function returnTypeEntityQueryObject() {
	return { name: "return_type_entity" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableEntityQueryObject() {
	return { name: "return_type_nullable_entity" };
}

/**
* @return {QueryObject}
*/
export function returnTypeStructQueryObject() {
	return { name: "return_type_struct" };
}

/**
* @return {QueryObject}
*/
export function returnTypeRowidQueryObject() {
	return { name: "return_type_rowid" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableRowidQueryObject() {
	return { name: "return_type_nullable_rowid" };
}

/**
* @return {QueryObject}
*/
export function returnTypeGtvQueryObject() {
	return { name: "return_type_gtv" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableGtvQueryObject() {
	return { name: "return_type_nullable_gtv" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListIntegerQueryObject() {
	return { name: "return_type_list_integer" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListBooleanQueryObject() {
	return { name: "return_type_list_boolean" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListByteArrayQueryObject() {
	return { name: "return_type_list_byte_array" };
}

/**
* @return {QueryObject}
*/
export function returnTypeSetIntegerQueryObject() {
	return { name: "return_type_set_integer" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListStructQueryObject() {
	return { name: "return_type_list_struct" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableListStructQueryObject() {
	return { name: "return_type_nullable_list_struct" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListEntityQueryObject() {
	return { name: "return_type_list_entity" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableListEntityQueryObject() {
	return { name: "return_type_nullable_list_entity" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListGtvQueryObject() {
	return { name: "return_type_list_gtv" };
}

/**
* @return {QueryObject}
*/
export function returnTypeListListListQueryObject() {
	return { name: "return_type_list_list_list" };
}

/**
* @return {QueryObject}
*/
export function returnTypeSetGtvQueryObject() {
	return { name: "return_type_set_gtv" };
}

/**
* @return {QueryObject}
*/
export function returnTypeMapQueryObject() {
	return { name: "return_type_map" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableMapQueryObject() {
	return { name: "return_type_nullable_map" };
}

/**
* @return {QueryObject}
*/
export function returnTypeEnumMapQueryObject() {
	return { name: "return_type_enum_map" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableEnumMapQueryObject() {
	return { name: "return_type_nullable_enum_map" };
}

/**
* @return {QueryObject}
*/
export function returnTypeAnyMapQueryObject() {
	return { name: "return_type_any_map" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNamedTupleQueryObject() {
	return { name: "return_type_named_tuple" };
}

/**
* @return {QueryObject}
*/
export function returnTypeNullableNamedTupleQueryObject() {
	return { name: "return_type_nullable_named_tuple" };
}

/**
* @param {number} since
* @return {QueryObject}
*/
export function returnTypeNamedTupleListQueryObject(since) {
	assertNumber(since)
	return { name: "return_type_named_tuple_list", args: { since: since } };
}

/**
* @return {QueryObject}
*/
export function returnTypeUnnamedTupleQueryObject() {
	return { name: "return_type_unnamed_tuple" };
}

/**
* @param {number} since
* @return {QueryObject}
*/
export function returnTypeProposalsSinceQueryObject(since) {
	assertNumber(since)
	return { name: "return_type_proposals_since", args: { since: since } };
}

/**
* @return {QueryObject}
*/
export function inputParameterNargsQueryObject() {
	return { name: "input_parameter_nargs" };
}

/**
* @param {string} t
* @return {QueryObject}
*/
export function inputParameterTextQueryObject(t) {
	assertString(t)
	return { name: "input_parameter_text", args: { t: t } };
}

/**
* @param {string | null} t
* @return {QueryObject}
*/
export function inputParameterNullableQueryObject(t) {
	if (t != null) assertString(t)
	return { name: "input_parameter_nullable", args: { t: t } };
}

/**
* @param {TestEnum} e
* @return {QueryObject}
*/
export function inputParameterEnumQueryObject(e) {
	assertNumber(e)
	return { name: "input_parameter_enum", args: { e: e } };
}

/**
* @param {number} i
* @return {QueryObject}
*/
export function inputParameterIntegerQueryObject(i) {
	assertNumber(i)
	return { name: "input_parameter_integer", args: { i: i } };
}

/**
* @param {bigint} i
* @return {QueryObject}
*/
export function inputParameterBigIntegerQueryObject(i) {
	assertBigInteger(i)
	return { name: "input_parameter_big_integer", args: { i: i } };
}

/**
* @param {number} b
* @return {QueryObject}
*/
export function inputParameterBooleanQueryObject(b) {
	assertNumber(b)
	return { name: "input_parameter_boolean", args: { b: b } };
}

/**
* @param {number} r
* @return {QueryObject}
*/
export function inputParameterRowidQueryObject(r) {
	assertNumber(r)
	return { name: "input_parameter_rowid", args: { r: r } };
}

/**
* @param {Buffer} pubkey
* @return {QueryObject}
*/
export function inputParameterPubkeyQueryObject(pubkey) {
	assertBuffer(pubkey)
	return { name: "input_parameter_pubkey", args: { pubkey: pubkey } };
}

/**
* @param {Buffer} blockchainRid
* @return {QueryObject}
*/
export function inputParameterBlockchainRidQueryObject(blockchainRid) {
	assertBuffer(blockchainRid)
	return { name: "input_parameter_blockchain_rid", args: { blockchain_rid: blockchainRid } };
}

/**
* @param {number} e
* @return {QueryObject}
*/
export function inputParameterEntityQueryObject(e) {
	assertNumber(e)
	return { name: "input_parameter_entity", args: { e: e } };
}

/**
* @param {TestStruct} s
* @return {QueryObject}
*/
export function inputParameterStructQueryObject(s) {
	assertObject(s)
	return { name: "input_parameter_struct", args: { s: Object.values(s) } };
}

/**
* @param {Buffer[]} v
* @return {QueryObject}
*/
export function inputParameterListInputQueryObject(v) {
	assertArray(v)
	return { name: "input_parameter_list_input", args: { v: v } };
}

/**
* @param {Buffer[] | null} v
* @return {QueryObject}
*/
export function inputParameterNullableListInputQueryObject(v) {
	if (v != null) assertArray(v)
	return { name: "input_parameter_nullable_list_input", args: { v: v } };
}

/**
* @param {Set<Buffer>} v
* @return {QueryObject}
*/
export function inputParameterSetInputQueryObject(v) {
	assertSet(v)
	return { name: "input_parameter_set_input", args: { v: Array.from(v) } };
}

/**
* @param {Record<string, Buffer>} v
* @return {QueryObject}
*/
export function inputParameterMapInputQueryObject(v) {
	assertObject(v)
	return { name: "input_parameter_map_input", args: { v: v } };
}

/**
* @param {Array<[TestEnum, Buffer]>} m
* @return {QueryObject}
*/
export function inputParameterEnumMapQueryObject(m) {
	assertArray(m)
	return { name: "input_parameter_enum_map", args: { m: m } };
}

/**
* @param {Array<[TestStruct, Buffer]>} m
* @return {QueryObject}
*/
export function inputParameterAnyMapQueryObject(m) {
	assertArray(m)
	return { name: "input_parameter_any_map", args: { m: m } };
}

/**
* @param {string} s
* @param {string} s2
* @return {QueryObject}
*/
export function inputParameterMultipleQueryObject(s, s2) {
	assertString(s)
	assertString(s2)
	return { name: "input_parameter_multiple", args: { s: s, s2: s2 } };
}

/**
* @param {RawGtv} g
* @return {QueryObject}
*/
export function inputParameterGtvQueryObject(g) {
	assertAny(g)
	return { name: "input_parameter_gtv", args: { g: g } };
}

/**
* @param {RawGtv} g
* @return {QueryObject}
*/
export function inputParameterNullableGtvQueryObject(g) {
	if (g != null) assertAny(g)
	return { name: "input_parameter_nullable_gtv", args: { g: g } };
}

/**
* @param {TestEnum} e
* @return {QueryObject}
*/
export function myNs1Q1InNamespaceQueryObject(e) {
	assertNumber(e)
	return { name: "my_ns1.q1_in_namespace", args: { e: e } };
}

/**
* @param {MyNs1TestStruct2} s
* @return {QueryObject}
*/
export function myNs1Q2InNamespaceQueryObject(s) {
	assertObject(s)
	return { name: "my_ns1.q2_in_namespace", args: { s: Object.values(s) } };
}

/**
* @param {MyNs1LocalTestEnum} e
* @return {QueryObject}
*/
export function myNs1Q3aReturnTypeEnumQueryObject(e) {
	assertNumber(e)
	return { name: "my_ns1.q3a_return_type_enum", args: { e: e } };
}

/**
* @param {Array<[TestEnum, Buffer]>} m
* @return {QueryObject}
*/
export function myNs1Q3bReturnTypeEnumQueryObject(m) {
	assertArray(m)
	return { name: "my_ns1.q3b_return_type_enum", args: { m: m } };
}

/**
* @param {Array<[Buffer, MyNs1MyNs12TestStruct2]>} m
* @return {QueryObject}
*/
export function myNs1Q4ReturnTypeListStructQueryObject(m) {
	assertArray(m)
	return { name: "my_ns1.q4_return_type_list_struct", args: { m: m } };
}

/**
* @param {MyNs1LocalTestStruct[]} v
* @return {QueryObject}
*/
export function myNs1Q5ReturnTypeListStructQueryObject(v) {
	assertArray(v)
	return { name: "my_ns1.q5_return_type_list_struct", args: { v: v } };
}

/**
* @return {QueryObject}
*/
export function myNs1Q6ReturnTypeListStructQueryObject() {
	return { name: "my_ns1.q6_return_type_list_struct" };
}

/**
* @return {QueryObject}
*/
export function myNs1Q7ReturnTypeEnumMapQueryObject() {
	return { name: "my_ns1.q7_return_type_enum_map" };
}

/**
* @return {QueryObject}
*/
export function myNs1Q8ReturnTypeEnumMapQueryObject() {
	return { name: "my_ns1.q8_return_type_enum_map" };
}

/**
* @return {QueryObject}
*/
export function myNs1Q9ReturnTypeAnyMapQueryObject() {
	return { name: "my_ns1.q9_return_type_any_map" };
}

/**
* @return {QueryObject}
*/
export function myNs1Q10ReturnTypeAnyMapQueryObject() {
	return { name: "my_ns1.q10_return_type_any_map" };
}

/**
* @return {QueryObject}
*/
export function myNs1MyNs2Q2InNamespaceQueryObject() {
	return { name: "my_ns1.my_ns2.q2_in_namespace" };
}

/**
* @return {QueryObject}
*/
export function myNs1MyNs2Q3InNamespaceQueryObject() {
	return { name: "my_ns1.my_ns2.q_3_in_namespace" };
}

/**
* @return {Operation}
*/
export function beforeQueryTestOperation() {
	return { name: "before_query_test" };
}
